Contents

ADVANSYS

Formativ

GroupWise Customization Made Easy!

Business Solutions Pack Guide

A guide to using the Business Solutions Pack 1.6 Applets

Advansys Formativ Business Solution Pack Guide

Information in this document is subject to change without notice. The example companies, products and people are purely fictitious. Without limiting the rights under copyright, no part of this document may be reproduced, stored or introduced into a retrieval system, or transmitted in any form without prior written approval of Advansys corporation.

Advansys may have patents, patent applications, trademarks, copyrights, or other intellectual property rights covering the subject matter in this document. Except as expressly provided in any written license agreement from Advansys, the furnishing of this document does not give you any license to these patents, trademarks, copyrights or other intellectual property.

Copyright © 2002-2003 Advansys Pty Limited. All rights reserved.

Formativ is a trademark of Advansys Pty Limited in Australia and other countries.

GroupWise is a trademark of Novell Inc.

Visual Basic Script is a trademark of Microsoft Corporation.


Getting Help from Advansys Technical Support

If you are currently online, select one of the following links to access the appropriate support resource:

Formativ Updates Page

There may be an update that addresses your problem. This page should be your first stop should you encounter a problem.

Formativ Support Page

The Formativ Support page contains links to various support resources.

Advansys Formativ Frequently Asked Questions (FAQ)

Advansys maintains a list of frequently asked questions about Formativ. Check this page to see if the answer to your question has already been documented.

Formativ Support Forums

Advansys provides technical support for Formativ via online moderated forums. These web-based forums are moderated by Advansys technical staff and represent the primary source of support for Formativ. Feel free to log in and post a question or search the existing forums to see if your question has already been answered.


Address Book Publisher

Overview

This applet publishes the contents of a given GroupWise address book using Microsoft Word, resulting in a printable address book listing. The applet provides numerous publishing options, including page size and address book fields to include. You are free to modify the Microsoft Word template used by the applet to produce a directory that reflects your own look and feel.

This applet was developed and tested using Microsoft Word 2000.

Operation

Execute the applet and follow the Wizard. You will be asked to select an address book to publish and some simple options that control the look and feel of the final Word document. Once the process is complete, switch to Microsoft Word and print the document.

Modifying the Word Template

The applet uses a Microsoft Word document called CorporateDirectory.doc that must be located in the Formativ Data directory. This is the document you edit to change the appearance of the final Word address book listing. The applet uses styles defined in the document to control the formatting of each printed element. Edit these styles to change the appearance of each element.

Suggested GroupWise Integrations

On the main GroupWise toolbar


Add or Edit Message Note

Overview

This applet lets you add free form textual notes to any GroupWise item. If you send a GroupWise item that contains a note to another user who also has this applet, they will be able to read and edit the notes you have added.

Operation

Select a single item in the GroupWise client and execute the applet. If a note has already been attached to the message, it will be displayed in the note editing dialog, where it can be edited further. If no notes have been added, the note editing dialog will be displayed in which you add note text.

The applet creates a custom field called Advansys Note in your GroupWise account. You may add this field to the fields displayed in the GroupWise client to see which items have notes attached (Right mouse click on the column heading of a GroupWise list view and add the field.)

You can use the standard GroupWise search and find techniques to search for text found in your notes. When searching, specify you wish to search in all fields and select Advansys Note.

Suggested GroupWise Integrations

On the main GroupWise toolbar

On the email context menu

On the email toolbar


Calendar Dates Importer

Overview

This applet lets you import groups of dates into your GroupWise calendar. You can use this applet to import categories of dates, such as public holidays, meeting dates, corporate function dates, birthdays, etc. The applet has full rollback support, which means you can automatically remove the dates from your calendar at any time.

A date creation applet (Create a date import file) is also included. It assists in the creation of date import files used to store the dates that are imported.

Operation

Execute the applet and follow the Wizard. A list of available dates is shown. Check one or more series of dates, select whether you want to import the dates as GroupWise Notes or Appointments, then press next. The applet automatically adds all the dates contained in the selected date files.

You may remove imported dates at any time by running the applet again and selecting the rollback option.

Support Files

This applet looks in the Formativ Data directory for any files with a .txt extension. These files are assumed to be date import files. These are clear text files containing date information encoded as follows, one per line:

DATE|Date Description

The date are encoded using the following convention:

YYYYMMDDTHHMMSS, where

YYYY represents the current year, eg. 2001

MM represents the month number, eg. 10 = October

DD represents the day of the month number, eg. 06

Everything after and including the T represents the time, which is not used by the applet (but must be present).

You can either manually create date import files using the above convention and a text editor such as Notepad, or you can use the associated applet called Calendar Dates Creator, which prompts you for dates and creates the file in the correct format.

Suggested GroupWise Integrations

On the main GroupWise toolbar


Create Word Mail Merge Source

Overview

This applet creates a Microsoft Word mail merge source document based on the contents of a selected GroupWise address book. You can use the resultant mail merge source document to produce mailing labels, letters, memos etc in Microsoft Word.

Operation

Execute the applet and follow the Wizard. You will be asked to select an address book. Once selected, the applet builds a Word mail merge data file. This file consists of a table that contains a header row, then one row for each address book entry found. You can then use the standard Word mail merge functions, using the generated document as the data file.

Suggested GroupWise Integrations

On the main GroupWise toolbar


Day Blocker

Overview

This applet lets you quickly and easily block out either a single day, or series of days in your GroupWise calendar. Full day appointments are created on the days you wish to block out of your calendar. This applet is useful for when you are going on vacation or will be out of the office for some other reason, and wish to mark your calendar as being 'out of the office'. You are able to specify the subject, location and message text of the appointments that will be created.

Operation

Execute the applet and follow the Wizard. You will be asked to indicate the the date you will be first out of the office, and the date you return. You also supply the subject, place and body text for the GroupWise appointments created by the applet. Once you have supplied this information the applet creates single day appointments on each day of the period you will be out of the office.

Once you have added appointments to your calendar you may automatically remove them using the same applet. Simply execute the applet again at any time in the future and select the Rollback button (the rollback button only appears if you have previously used the applet to block out days in your calendar).

Suggested GroupWise Integrations

On the main GroupWise toolbar


Find Contacts in Address Books

Find Contacts in Address Book

Overview

This applet lets you search across any number of GroupWise address books for specified text, and optionally lets you compose email messages to any address book entries that meet your search criteria. For example, you could search for all contacts that contain the text 'ACME Corporation', and then compose email messages to those contacts.

Operation

Execute the applet and follow the Wizard. Enter the text you wish to search for, then select the address books to search in. If any matches are found, a dialog is shown containing those entries. Select any entries you are interested in and press next. The applet automatically creates draft messages to each matching entry.

Suggested GroupWise Integrations

On the main GroupWise toolbar


Internet Reply Formatter

Overview

This applet lets you format email replies using the standard '>' quoting system. For example, if you reply to a message and execute this applet, the original message text has any soft line breaks converted to hard line breaks, and the '>' character is inserted at the start of each line as shown below:

>Dear Sir,

>

>Thank you very much for your email message.

>We were very happy with your proposal and look

>forward to hearing from you soon.

Operation

Reply to a message and execute the applet. The original message text will be automatically formatted using the convention described above.

Suggested GroupWise Integrations

On the email toolbar

On the email On Reply event


Mulitple Signatures

Multiple Signatures

Overview

This applet introduces support for multiple signatures that you can attach to new email messages, or to replies. Multiple signatures are useful when you have several email 'personas'. For example, you may wish to use a more informal signature when replying to internal email, and a formal signature when creating email for external recipients. While GroupWise provides signature capability, you are limited to a single signature per account.

You can use both plain text and rich HTML signatures. HTML signatures can contain any valid HTML element, including fonts, colors, links and graphics.

You should disable the standard GroupWise signature facility when using this applet.

Creating Signature Files

To use this applet, you must first create a signature file for each signature you wish to use. A signature file is either a simple text file, or a HTML file. Use your favorite text editor or Notepad to create plain text signature files. Use your favorite HTML editor to create rich content HTML signatures.

An example of a simple signature might be:

Bill Smith

Sales Manager

ACME Inc

bill@acme.com.au

You should save the text file using a descriptive name, such as Informal Signature.

If you are creating plain text files, use the .SIG file extension when saving the file. For example, you might save your informal signature in a file called Informal Signature.sig. If you are creating HTML signature files, use either the .HTM or .HTML extensions when saving the file. For example, you might save your informal signature in a file called Informal Signature.htm.

Save your signature files to the Formativ signature directory. The default is 'C:\Program Files\Advansys\Formativ\Data\Signatures'. You can change this location by pressing the Settings... button from the main signature dialog and selecting the appropriate directory.

Operation

When the applet is executed, a list of available signatures is displayed. A check box is displayed next to each signature. Use the check boxes to specify a default signature. You may only define one default signature.

To use a signature, select it from the list and press OK. The signature is added to your message.

If you have defined a default signature, you can insert it without having to display the selection dialog. Hold down the SHIFT key when the applet is executed to automatically insert the default signature.

Suggested GroupWise Integrations

On the email On Compose event

On the email On Reply event

On the Email dialog toolbar


Out of the Office Rule

Overview

This applet assists in the creation of a GroupWise rule that notifies senders that you are currently not in the office. The rule is created in such a manner as not to create email storms.

Operation

Execute the applet and follow the Wizard. You can choose the types of incoming items to respond to, the dates in which you will be out of the office, the subject and body text of the reply that will be sent when items arrive, and specify email addresses that will be excluded from the rule's operation.

Once applet execution is complete you may manually edit the rule created.

Suggested GroupWise Integrations

On the main GroupWise toolbar


Personalized Mass Email

Overview

This applet lets you create and send personalized mass email messages using data from your GroupWise address books. You create a base document containing field markers that are replaced with the appropriate fields from the address book for each recipient. A base document can be plain text, HTML or a MIME document. Plain text source documents result in plain text messages being generated. HTML and MIME documents contain rich content, and result in messages that can contain different fonts, color, layout, links and graphics. The difference between HTML and MIME documents is that an HTML document requires links to external images (if images form part of your template), whereas a MIME document embeds any images within the MIME document itself.

Source Documents - Overview

In order to create a personalized mass mailing, you first need to create a source document. A source document contains the base text of the message, along with field markers indicating the GroupWise address book fields to be inserted during the merge process. You can include data from any address book field in your message.

Address book fields are denoted by double square brackets. For example:

Dear [[First Name]],

We would like to welcome [[Organization]] as a customer of ACME Corp.

The following field names are supported:

[[EmailAddress]]
[[FirstName]]
[[LastName]]
[[DisplayName]]
[[Organization]]
[[Address]]
[[City]]
[[State]]
[[ZipCode]]
[[Country]]
[[Department]]
[[Title]]
[[Greeting]]
[[HomePhone]]
[[OfficePhone]]
[[FaxPhone]]
[[CellPhone]]
[[Comments]]

Plain Text Source Documents

The simplest type of source document is plain text. Messages created from plain text source documents do not contain any formatting. You can create them using any text editor. You can also create them using your favorite word processing application, and save the document as plain text.

Once you have created your HTML stationery file, copy it to the directory defined under Settings... in the applet. The default is 'C:\Program Files\Advansys\Formativ\Data\Mass Email Templates'.

HTML Source Documents

You can create a source document using HTML. HTML source documents can contain any valid HTML element, including fonts, colors, layout information, links and graphics.

Create HTML source documents using your favorite HTML or text editor. How to create HTML documents is beyond the scope of this documentation. If you require assistance, we recommend you obtain one of any number of excellent books on HTML, or access one of the numerous Internet resources.

You may only include images that exist on a server connected to the Internet. Your recipients require access to this server in order for them to see the graphics you include. This means you need to use the complete URL of any images in your template. You cannot use relative paths.

Once you have created your HTML stationery file, copy it to the directory defined under Settings... in the applet. The default is 'C:\Program Files\Advansys\Formativ\Data\Mass Email Templates'.

MIME Source Documents

You can create source documents using a MIME encoded file. A MIME encoded file is similar to a HTML source document, except that any images it references are embedded into the document. This removes the need to reference external image files as is the case with normal HTML templates.

By far the easiest way to create a MIME source document is to use GroupWise. GroupWise creates a MIME document whenever you create a HTML formatted email message.

To create a MIME source document using GroupWise:

Create a new email message in GroupWise. Ensure you are editing in HTML mode.

Add all formatting, field markers, links and graphics to the draft message.

Save the message into the GroupWise Work in Progress folder

The message should have an attachment called mime.822. Save this attachment to your mass email template directory. The default is 'C:\Program Files\Advansys\Formativ\Data\Mass Email Templates'.

Change the extension of the file from .822 to .MME

Performing the Merge

Once you have created a source document and saved it into the appropriate directory, you are ready to perform the merge:

Execute the applet, select the appropriate template from the list. Press Next...

You are given the opportunity to provide a plain text version of your message for recipients who are unable to view HTML formatted messages. Enter an appropriate message and press OK

Select one or more address books from the list. A message will be generated to each recipient from each of the selected books

Optionally, select one or more exclusions address books. If a recipient is also found in an exclusion address book, that recipient will not be included in the process, and no message will be created for that recipient. Press Next...

Enter a subject for the messages. You can also choose to have the applet make allowances for incorrect case in the first and last names

Choose if you wish to send the generated messages now, or if you wish to place the generated messages in the Work in Progress folder. Press Next...

If you indicated the messages were to be sent immediately, the messages are generated and the process is complete. If you indicated the messages were to be saved in the Work in Progress folder, the messages are generated and saved into Work in Progress. You can now manually review the messages in the Work in Progress folder, optionally making any changes deemed necessary.

When you are ready to send the message, execute the applet again. The pending messages are detected, and you will be asked if you would like to send the messages now. Select yes to send the messages.

Note: Generated Work in Progress messages will not contain recipient information in the To field. This information is stored internally, and added by the applet as each message is sent.

Suggested GroupWise Integrations

On the main GroupWise toolbar


Publish Folder List

Overview

This applet publishes to Microsoft Word a list of the currently selected GroupWise mailbox messages. The messages are color coded to indicate type and priority.

This applet was developed and tested using Word 2000.

Operation

Select the items in GroupWise you wish to print a list of and execute the applet. Microsoft Word is automatically started and the list is built. You need to switch to Word at the completion of the applet to see the list.

Suggested GroupWise Integrations

On the main GroupWise toolbar


Quick Proxy

Overview

The Quick Proxy applet lets you proxy to a predefined account with a single click. This is particularly useful if you have a corporate account, or some other account which you often proxy to. This applet removes the need to have to manually display the proxy dialog, select the appropriate account, and finally press the proxy button.

You need to have proxy rights to the appropriate account for this applet to work.

Operation

The first time the applet is executed you will be prompted to enter the user ID of the account to proxy to. Enter the user ID and press OK. Assuming you have proxy rights to the account, you will be automatically proxied to the account. If you execute the applet again, you will be returned to your own account. Each time the applet is executed you will be proxied between the defined account and your own account.

Change the account you wish to proxy to by holding down the CTRL key while executing the applet. The proxy user ID dialog will appear from where you can specify the new user ID to proxy to.

Suggested GroupWise Integrations

On the main GroupWise toolbar


Quick Recipients

Overview

The Quick Recipients applet lets you automatically create and address a single email message with addresses either from an address book or from a text file. It is particularly useful when using a text file.

Operation

Execute the applet and follow the Wizard. You can either use an address book or a simple text file of email addresses as your addressing source. In either case, specify whether you wish to address the messages using the TO or CC fields.

If you are using an address book, select the appropriate address book from the list shown.

If you are using a text file, select the appropriate file using the file browser. The text file you select must be a simple text file containing fully qualified email addresses, one per line. For example:

test@test.com

barry@test.com

sales@acme.com

The applet creates a new email message from yourself and addresses it using data either from the selected address book or text file. Once the applet is complete you are free to manually compose the rest of the email.

Suggested GroupWise Integrations

On the main GroupWise toolbar


Stationery

Overview

The Formativ Stationery applet was developed to provide quick access to your library of HTML email stationery. Each stationery template is first created with a HTML editor, such as FrontPage, HoTMetaL etc. and can include tables, colors and images (yes, including animated GIFs!), such as your corporate logo. You can create a standard email 'letterhead' as well as special templates which may have graphics or text to promote a new product or special pricing. And of course, you can include active URL links back to your product, home or even a special promotion page. As there is no limit on the number of stationery templates you can access with the Formativ Stationery applet, the form and function of your email stationery is limited only by your imagination!

One other advantage of the Formativ Stationery applet is that you can insert more than one stationery form into the same message. In the message body text area, position your cursor where you want the stationery to start, run the applet and your selected stationery will be inserted. To achieve various designs or function, you could create stationery 'building blocks' and use the applet to append them. For example, to tailor your correspondence, you could use generic company stationery, and append stationery which promotes a new product or service.

The applet is configured for placement on the GroupWise main and/or a message view toolbar, where it can be executed at the touch of a button. This means that you can use your Formativ stationery for your other GroupWise message types, such as appointments, tasks, phone messages and notes!

To add further flair and function to your stationery based messages, you can also use the Formativ Multiple Signatures applet in conjunction with the Formativ Stationery applet.

Operation

Execute the applet and select the appropriate item of stationery from the list. You can use the drop down list in the top right hand side of the dialog to change the category of stationery to select from. Click once on the item of stationery you wish to use. If you have a composing item active, the stationery will be inserted into the item. If no composing item is available, the applet creates a new email message and inserts the stationery.

Click the Edit hotspot to change the name, subject and category for each item of stationery. Click the Delete hotspot to delete an item of stationery. Click the Default hotspot to specify an item of stationery as the default (see below).

Default Stationery

You can specify that a particular item of stationery is to be the default (see above). The default stationery can be used without displaying the stationery selection dialog by holding down the SHIFT key when the applet is executed.

Creating your HTML email stationery

The key to maximizing the benefit from the Formativ Stationery applet is to create good-looking and functional email stationery. There are two ways to create HTML stationery. You can use your favorite HTML editor, or use the HTML message composition feature of GroupWise itself in conjunction with the Stationery Creator applet.

Both approaches have advantages and disadvantages. For example, manually creating stationery using a HTML editor requires knowledge of HTML, and you need to manually create a special directory on your PC using a specific naming convention to save your stationery, but you get ultimate control over its appearance. Using the Stationery Creator applet requires no knowledge of HTML or how/where to save the file, but at the cost of limited creativity in designing the stationery.

We are going to focus on using an external HTML editor for the remainder of this discussion, but you can learn more about converting existing HTML messages into stationery here .

As the in built GroupWise HTML message editing is limited, we'll introduce you to techniques which allow you to use tables, background colors, formatted text, graphics (including animated GIFs!) and hypertext links within your email stationery.

HTML stationery are simply HTML files. You can create HTML files using any text editor, but it is far more efficient to use a dedicated HTML editor. You can use any HTML authoring product with which you are familiar. Once you have created a HTML file to use as stationery, you need to save it to a particular location on your computer. See Stationery Location below for more information on where to save your stationery.

Some techniques used to create GroupWise email stationery are outlined below. It should be noted that these suggestions are not exhaustive and there may be other techniques which you can use. However, you should be aware that there are limitations on the HTML which you can use within a GroupWise message and you will need to test any new techniques and designs.

Tables

Tables are a great way to lay out your stationery, particularly when combined with CSS parameters (discussed below). You can choose to embed tables and you can create full width or fixed width tables. You can also use the background color property in the table and cell HTML codes.

Images

Image and URL references should not be made relative (i.e. IMG SRC="images/advansys.gif") within your HTML document, i.e. you need to explicitly specify the full path to the image or the target URL.

For example, for images you can write your HTML source as follows:

<IMG SRC="http://www.advansyscorp.com/images/advansys.gif" ALT="Advansys Header" WIDTH="178" HEIGHT="28">

(the above refers to a graphic on a web server)

or

<IMG SRC="file:///c:/web/images/advansys.gif" ALT="Advansys Header" WIDTH="178" HEIGHT="28">

(the above refers to a graphic stored on the workstation local drive).

Remember that you can also use animated GIFs to add pizzazz to your stationery.

It should be noted that, after the stationery is selected and the message is sent, GroupWise will add all stationery images as message attachments. It is not possible to add an image to a GroupWise message only as a remote link -- it will always be included as an attachment when your message is sent.

Web Page Links

When you wish to reference a Web page link from your stationery text or image, you need to use fully qualified URLs, i.e. http://www.website.com/page.html, just like you do when including images (see above). For example, if in the stationery we wish to reference the What's New page on the Advansys web site, we need to use the following code:

<A HREF="http://www.advansyscorp.com/whatsnew.htm">What's New</A>

CSS Parameters

Style sheet parameters provide very powerful control over how your stationery will look. Most of the latest HTML browsers, such as Microsoft Internet Explorer 5 and above, support CSS. Due to HTML constraints within GroupWise messages, you cannot embed CSS HTML style sheets in your stationery. The good news is that you can include CSS parameters, but they must be inserted within the specific parent code which you are formatting. For example, the following CSS parameters are being used to modify the style properties of a hypertext link <A HREF></A> HTML code:

<A HREF="http://www.advansyscorp.com/whatsnew.htm" STYLE="font-family: Arial, Verdana, Helvetica, sans-serif; font-size: small; font-weight: bold; text-decoration: none; color: #2B4FA4">What's New</A>

Page Background Image and Color

A background image or color embedded in the stationery will not display in the message, but you can manually add them via the GroupWise message's HTML editing toolbar, before or after the Formativ Stationery applet is run and the stationery is loaded. However, you can use background colors for tables and other HTML codes in your stationery, such as Table cells, etc.

Stationery Location

Each item of Formativ stationery needs to be saved to its own special directory on your computer. You cannot save more than one stationery file in the same directory.

Each stationery directory must appear directly under the main stationery directory. The default is 'C:\Program Files\Advansys\Formativ\Data\Stationery'.

The name of the directory used to store an individual item of stationery is important. The name of the directory is used to define both the display name of the stationery, and the category the stationery appears under in GroupWise. The first part of the directory name consists of the category name the stationery should appear under, enclosed in square brackets. The remainder of the name represents the display name of the stationery. There is no space between the category name and the display name components.

For example, if you created a new item of stationery called Promotion.htm, and you wanted it to appear in a category called Sales, you would need to create a directory under the main stationery directory called:

[Sales]Promotion

If your Formativ installation was standard, the full path of the location where Promotion.htm needs to be saved would be:

C:\Program Files\Advansys\Formativ\Data\Stationery\[Sales]Promotion

You can change the location of the base stationery directory by pressing the Settings... button on the main stationery dialog and selecting a new directory.

IMPORTANT: You need to copy all the support files, such as images, to the same directory as the stationery file itself.

Suggested GroupWise Integrations

On the main GroupWise toolbar


Stationery Creator

Overview

The Stationery Creator applet lets you convert any existing HTML GroupWise message into a stationery file that can be re-used over and over again with the Stationery Applet. You can convert any existing HTML message, or you can create a new HTML message, use the in-built editor to add text, color and graphics to the message, then convert it to stationery.

The Stationery Creator applet is the easiest way to create new stationery, requiring no knowledge of HTML.

Convert existing message to stationery

To create stationery from an existing HTML message, simply select the message in GroupWise and execute the applet. You will be asked to provide a name, subject and category for the stationery. The name is used to uniquely identify the item. The subject is automatically inserted as the subject of the message when the stationery is used. The category is used to group stationery items into logical sections. Once you have supplied all three properties, click OK to create the stationery.

You can also change the location of where the stationery will be stored by clicking the Settings... button and selecting a new directory.

Create a new message and convert to stationery

You can take advantage of GroupWise's inherent HTML editing capabilities to create HTML stationery. Simply create a new message, ensuring you are working in HTML mode, then use the standard editing features to add text, formatting attributes (bold, italics, etc.) and images. You should periodically save your work to the Work in Progress folder using the Save Draft (CTRL+S) function.

When you are ready to convert the message to stationery, save the message again (CTRL+S), then execute the Stationery Creator applet. In some situations the applet may prompt you to save the message again, close the message, then reopen it. This is normal, and is due to the design of GroupWise.

You will be asked to provide a name, subject and category for the stationery. The name is used to uniquely identify the item. The subject is automatically inserted as the subject of the message when the stationery is used. The category is used to group stationery items into logical sections. Once you have supplied all three properties, click OK to create the stationery.

You can also change the location of where the stationery will be stored by clicking the Settings... button and selecting a new directory.

Once converted, you are free to use your new stationery with the Stationery Applet.

Suggested GroupWise Integrations

On the main GroupWise toolbar

On the Mail view toolbar


Search and Replace

Overview

This applet introduces search and replace functionality to items being composed in GroupWise. Simply associate this applet with GroupWise email, appointments, notes and tasks, and a new menu or toolbar button appears that lets you perform search and replace operations while composing items.

Operation

Execute the applet while composing an item. A dialog appears that allows you to perform a search and replace in the body text of the composing item.

Suggested GroupWise Integrations

On the toolbar and context menus of every message type to which you wish to add search and replace functionality


Template System

Overview

The Template System applet lets you create boilerplate GroupWise email, notes, appointments and tasks based on templates. These templates are both passive and dynamic, meaning they either create a new standard item, or they automatically build a dialog that collects information from the user, then build a message using data supplied by the user. You can also add a signature to the message. The signatures used are the same ones used by the Multiple Signatures applet.

Possible applications of the template system are wide and varied. A number of sample templates are installed which demonstrate the power of the system.

The Template system consists of two applets: The Message to Template applet and the Templates Applet. The Message to Template applet is used to convert existing GroupWise items into templates that can be used with the Template applet. For example, if you have a standard email message that you send on a regular basis, you can automatically create a template based on the message, then use the template system to create a new email based on the contents of the original message.

You can easily modify a template in order to have it prompt the user for information that is then used within the new item.

Operation

Location of Files

Each template is stored as an XML file in the Formativ Data directory. This is 'C:\Program Files\Advansys\Formativ\Data' by default, but may have been changed by your system administrator. Each template file must use the .XML file extension.

Creating a Template From An Existing Message

The easiest way to create a new template is to use the Message to Template applet. This applet converts the currently selected GroupWise item into a template and saves it to the data directory. Simply select the appropriate GroupWise item and execute the applet. You will be asked to provide a name for the template, after which the template file is created and saved into the data directory. You may then use the template as is by running the Template applet and selecting the new template from the list of templates displayed, or edit the new template as described in the following section.

Creating a Template Manually

The easiest way to create a new template is to first create a template automatically based on an existing item as described above, then manually edit the template to customize its contents. Use your favorite text editor, such as Notepad, to edit the XML template files. Take care not to change any of the XML tags (the data between the <> markers).

Editing Templates

You can manually edit templates to change their content. You can change the static content, such as the subject or body text, and you can also add dynamic content that is used to create forms that collect data from the user when the template is executed. This is an advanced topic that is covered in detail here.

Using Templates

Execute the applet and select the template you wish to use.

Suggested GroupWise Integrations

On the main GroupWise toolbar


Building Dynamic Templates

What are Dynamic Templates?

Dynamic Templates are Formativ templates that have been edited to make them interactive. A dynamic template is parsed by the template applet to dynamically build a dialog that is presented to the end-user, who then provides additional data. This data is then used along with the hard coded data in the template file to build a new GroupWise item. For example, you might create a dynamic template to display a dialog that collects information regarding a support issue. Several examples of dynamic templates ship with Formativ. You will find these in the Formativ Data directory.

The Anatomy of a Dynamic Template

Dynamic Templates are XML files. XML, or eXtensible Markup Language, is a standard means of formatting information, and is similar to HTML. You can edit XML files using any text editor, such as Notepad. A simple example is shown below, followed by a description of each component.

<?xml version="1.0" standalone="yes"?>

<Template autocreate="true" class="GW.MESSAGE.MAIL" title="Expenses Claim Form" description="Create an expenses form" signature="Support">- Employee Details -

Employee ID : <EditBox prompt="Employee ID" hint="Enter ID"></EditBox>

First Name : <EditBox prompt="First Name" hint="Enter first name" required="y"></EditBox>

- Expenses Details -

<DateTime prompt="Date Expense incurred:" hint="Enter the date" date="20/4/2001"></DateTime>

Expense Amount : <EditBox prompt="Expense amount $" hint="Enter the expense amount" required="y"></EditBox>

Additional Information -

<CheckBox prompt="I have notified my supervisor of the expense" hint="Did you inform your supervisor about the expenses" delsuffix="HRtn" addsuffix="HRtn" addprefix="Tab"></CheckBox>

<CheckBox prompt="I have claimed the same type of expense in past" hint="More details about the expenses" delsuffix="HRtn" addsuffix="HRtn" addprefix="Tab"></CheckBox>

<CheckBox prompt="This is the first time I am making this claim" hint="None" delsuffix="HRtn" addsuffix="HRtn" addprefix="Tab"></CheckBox>

Expense Details: <Memo prompt="Enter additional details" required="y"/>

</Template>

<?xml version="1.0" standalone="yes"?>

This line indicates that this is an XML document. Every template must contain this text as its first line.

<Template autocreate="true" class="[string]" title="[string]" description="[string]" signature="[string]" Sender="[string]" Recipient="[string]" Cc="[string]" Bc="[string]" Priority="[string]" Personal="[y|n]" IsAccepted="[y|n]" StartDate="[string]" EndDate="[string]" DueDate="[string]" TaskCategory="[string]" TaskPriority="[string]" IsPrivate="[y|n]" caption="[string]" sizeable="[y|n]" autosize="[y|n]" height="[number]" imagebackgroundcolor="[string]" wizardimage="[string]" showwizardimage="[y|n]">

This is the opening Template element which indicates that everything after the ending '>' and before the closing </Template> element at the end of the file represents the body of the new message. This element contains several attributes that are used to control how the template works. These attributes are:

autocreate="true"

This attribute indicates that this template will create a new item automatically. It should not be changed.

class="[string]"

This attribute indicates the type of GroupWise item this template creates. Possible values are:

GW.MESSAGE.MAIL - Creates a GroupWise email item

GW.MESSAGE.NOTE - Creates a GroupWise note

GW.MESSAGE.TASK - Creates a GroupWise task

GW.MESSAGE.PHONE - Creates a GroupWise phone message

GW.MESSAGE.APPOINTMENT - Creates a GroupWise appointment

You can also use custom message types, such as GW.MESSAGE.MAIL.PROJECTX. See your GroupWise administrator to see if there are any custom message types available for you to use with your templates.

description="[string]"

The description for the template. This text appears in any dialogs that are displayed to the user to remind them of the purpose of the template.

signature="[string]"

The name of the signature to be added to the end of the message once the template has been built. This must be the name of the template file you wish to use, without the trailing period and SIG extension.

Sender="[string]"

Specifies the fully qualified address of the sender of the created item. Separate addresses with semicolons (;).

Recipient="[string]"

Specifies the fully qualified addresses of the recipients of the created item. Separate addresses with semicolons (;).

Cc="[string]"

Specifies the fully qualified addresses of the CC recipients of the created item. Separate addresses with semicolons (;).

Bc="[string]"

Specifies the fully qualified addresses of the BC recipients of the created item. Separate addresses with semicolons (;).

Priority="[string]"

Specifies the priority of the created item - 1, 2 or 3.

Personal="[y|n]"

Specifies whether the created item is to be personal.

IsAccepted="[y|n]"

Specifies whether the created item is to be marked as accepted.

StartDate="[string]"

Specifies the start date/time of the created item. Format as an ISO date time.

EndDate="[string]"

Specifies the end date/time of the created item. Format as an ISO date time.

DueDate="[string]"

Specifies the due date/time of the created item. Format as an ISO date time.

TaskCategory="[string]"

Specifies the task category of the created item. Supply a single alpha character.

TaskPriority="[string]"

Specifies the task category of the created item. Supply a single digit.

IsPrivate="[y|n]"

Specifies whether the created item is to be marked as private.

caption="[string]"

Sets the dialog's Window title.

title="[string]"

Sets the main title of the dialog. As this title is a large font, the number of title words should be limited.

sizeable="[y|n]"

Controls whether the dialog height can be sized by the user.

autosize="[y|n]"

When AutoSize is true, the dialog will expand its height to make all controls visible until the maximum screen height is reached.

height="[number]"

Sets the dialog to the specified height

imagebackgroundcolor="[string]"

Sets the color or the background behind the Wizard Image. This will only display when the Wizard Image does not fully conceal the image panel, for example, if the dialog is resized. Use predefined color constants or a Hex RGB value.

wizardimage="[string]"

Sets the path to the bitmap image file (BMP) for the Wizard Image. Viewable Image size is 342H x 112W for Windows displaying Small Fonts and 424H x 141W for Windows displaying Large Fonts.

showwizardimage="[y|n]"

Controls the visibility of the Wizard Image panel.

Dynamic Controls

You may define a number of different controls in your templates. You may create Edit Boxes, Check Boxes, Memo Controls, Radio Buttons, and Drop down Lists. Each control type has both required and optional attributes. See the topics under the Controls section for details on creating controls for your templates. Details regarding the optional common attributes are shown below.

Each control you define returns text to your template if certain conditions are met. The text returned is used to replace the control XML when the template is constructed. For example, in the template above the following XML is used to define an edit box:

Employee ID : <EditBox prompt="Employee ID" hint="Enter ID"></EditBox>

This is an example of template text, which is inserted unchanged into the new message, and a control that appears in the templates dialog that prompts the user for data. In this example, an edit box will be displayed with the caption Employee ID, and with the help hint Enter ID. The text entered by the user would be inserted into the resulting message at the location where the EditBox attribute appears. For example, if the user entered ABC123 as the employee ID in the displayed dialog, the following text would be inserted in the created message:

Employee ID : ABC123

Formatting Attributes

Each dynamic control may define a number of optional attributes that are used to format the text around the control when the template is being processed. This allows you to specify a certain level of control over the message text formatting when user input either is or is not present. For example, you may wish to delete one or more blank template lines if the user does not input any text into a control or if the user does not check an option on the dialog.

The possible values for the options below are "HRtn", "Tab" and "Comma". You can include multiple values, in any order, separated by the comma character, i.e. "Tab,Comma,HRtn,HRtn". The sequence of values must match the sequence of characters which either already exist in the template (in the case of deletion) or which you wish to exist (in the case of additions).

delsuffix="HRtn" delsuffix indicates that the specified character will be deleted from the end of where the control text is specified.

addsuffix="HRtn" addsuffix indicates that the specified character will be added to the end of where the control text is specified.

addprefix="Tab" addprefix indicates that the specified character will be added to the beginning of where the control text is specified.

delprefix="Tab" delprefix indicates that the specified character will be deleted from the beginning of where the control text is specified.


Attachments

You can specify file attachments that are to be attached to GroupWise messages created by your templates. You specify attachments using the following XML code fragment:

<Attachments>

<value file="[string]"></value>

.

.

</Attachments>

file="[string]">

Specifies the full name and path of the file to be added to the message.


Check Box

The check box control adds a check box to the dialog. You define a check box with the following XML code fragment:

<CheckBox prompt="[text]" hint="[text]" checked="[y|n]" width="[number]" left="[number]"></CheckBox>

All attributes are optional. They are used as follows:

prompt="[text]"

Specifies the text prompt that appears to the left of the edit control.

hint="[text]"

Specifies the text that appears as a help hint when the user holds the mouse over the control in the dialog.

checked="[y|n]"

Specifies whether the check box should be initially checked.

width="[number]"

Specifies the maximum width of the edit box in pixels.

left="[number]"

Specifies the offset in pixels from the left hand side of the dialog.


DateTime Control

The DateTime control adds a date/time selector to the dialog. You define a date/time control with the following XML code fragment:

<DateTime prompt="[text]" hint="[text]" checked="[y|n]" time="[string]" showcheckbox="[y|n]" datemode="[number]" date="[string]" datetime="[string]" maxdate="[string]" mindate="[string]" kind="[number]" width="[number]" left="[number]"></DateTime>

All attributes are optional. They are used as follows:

prompt="[text]"

Specifies the text prompt that appears to the left of the control.

hint="[text]"

Specifies the text that appears as a help hint when the user holds the mouse over the control in the dialog.

checked="[y|n]"

Specifies whether the radio button should be initially checked.

time="[string]"

Specifies the selected time. Format as an ISO date/time.

showcheckbox="[y|n]"

Displays a check box next to the date or time.

datemode="[number]"

Determines the method of date selection used by the component.

date="[string]"

Specifies the selected date. Format as an ISO date/time.

datetime="[string]"

Specifies the selected date and time. Format as an ISO date/time.

maxdate="[string]"

Determines the latest allowable date that can be entered. Format as an ISO date/time.

mindate="[string]"

Determines the earliest allowable date that can be entered. Format as an ISO date/time.

kind="[number]"

Determines whether the component is a date selector or a time selector.

width="[number]"

Specifies the width of the control in pixels.

left="[number]"

Specifies the left position of the control in pixels.


Drop Down List

The drop down list control allows the user to select an item from a list of items. The selected item's caption is inserted in the template. You define a drop down list with the following XML code fragment:

<DropDownList prompt="[text]" hint="[text]" required="[y|n]" maxlength="[number]" height="[number]" width="[number]" left="[number] dropdowncount="[number]" droppeddown="[number]" itemindex="[number]" listtext="[text]">

<Option text="[text]"></Option>

.

.

.

</DropDownList>

All attributes are optional. They are used as follows:

prompt="[text]"

Specifies the text prompt that appears to the left of the edit control.

hint="[text]"

Specifies the text that appears as a help hint when the user holds the mouse over the control in the dialog.

required="[y|n]"

Specifies whether this is a required field.

text="[text]"

Specifies the default text in the control when first displayed.

maxlength="[number]"

Specifies the maximum number of characters a user may enter in the list box.

dropdowncount="[number]"

Specifies the maximum number of items displayed in the drop-down list.

droppeddown="[y|n]"

Specifies whether the list is dropped down or closed.

itemindex="[number]"

Indicates which item in the drop-down list is selected.

listtext="[text]"

Used to load the list with entries. Supply a string containing values separated by commas.

width="[number]"

Specifies the maximum width of the drop down list in pixels.

left="[number]"

Specifies the offset in pixels from the left hand side of the dialog.


Edit Control

The edit control allows a single line of textual input. You define an edit box with the following XML code fragment:

<EditBox prompt="[text]" hint="[text]" required="[y|n]" text="[text]" maxlength="[number]" passwordchar="[character]" width="[number]" left="[number]"></EditBox>

All attributes are optional. They are used as follows:

prompt="[text]"

Specifies the text prompt that appears to the left of the edit control.

hint="[text]"

Specifies the text that appears as a help hint when the user holds the mouse over the control in the dialog.

required="[y|n]"

Specifies whether this is a required field.

text="[text]"

Specifies the default text in the control when first displayed.

maxlength="[number]"

Specifies the maximum number of characters a user may enter in the list box.

passwordchar="[character]"

If specified, the given character will be echoed back to the user when entering data in the edit control, hiding the actual character being typed.

width="[number]"

Specifies the maximum width of the edit box in pixels.

left="[number]"

Specifies the offset in pixels from the left hand side of the dialog.


List Box

The List Box control allows the user to select an item from a list of items. The selected item's caption is inserted in the template. You define a drop down list with the following XML code fragment:

<ListBox prompt="[text]" hint="[text]" required="[y|n]" extendedselect="[y|n]" multiselect="[y|n]" height="[number]" width="[number]" tabwidth="[number] topindex="[number]" left="[number]" dropdowncount="[number]" droppeddown="[y|n]" selected="[number]" text="[text]">

<Option text="[text]"></Option>

.

.

.

</ListBox>

All attributes are optional. They are used as follows:

prompt="[text]"

Specifies the text prompt that appears to the left of the edit control.

hint="[text]"

Specifies the text that appears as a help hint when the user holds the mouse over the control in the dialog.

required="[y|n]"

Specifies whether this is a required field.

text="[text]"

Specifies the default text in the control when first displayed.

extendedselect="[y|n]"

Determines if the user can select a sequential range of items in the list box.

multiselect="[y|n]"

Determines whether the user can select more than one element at a time.

tabwidth="[number]"

Specifies the size of the tabs in the list box.

topindex="[number]"

Specifies the index number of the item that appears at the top of the list box.

listtext="[text]"

Used to load the list with entries. Supply a string containing values separated by commas.

dropdowncount="[number]"

Specifies the maximum number of items displayed in the drop-down list.

droppeddown="[y|n]"

Indicates whether the drop-down list is currently displayed.

selected="[number]"

Indicates the first selected item in the list view.

width="[number]"

Specifies the maximum width of the drop down list in pixels.

left="[number]"

Specifies the offset in pixels from the left hand side of the dialog.


Memo Control

The memo control creates a multi line edit control in the dialog. You define a memo control with the following XML code fragment:

<Memo prompt="[text]" hint="[text]" required="[y|n]" text="[text]" wordwrap="[y|n]" width="[number]" height="[number]" left="[number]" maxlength="[number]" scrollbars="[y|n] readonly="[y|n]" wantreturns="[y|n]" wanttabs="[y|n]"></Memo>

All attributes are optional. They are used as follows:

prompt="[text]"

Specifies the text prompt that appears to the left of the edit control.

hint="[text]"

Specifies the text that appears as a help hint when the user holds the mouse over the control in the dialog.

required="[y|n]"

Specifies whether this is a required field.

text="[text]"

Specifies the default text in the control when first displayed.

wordwrap="[y|n]"

Specifies if words are to be wrapped within the label.

width="[number]"

Specifies the maximum width of the edit box in pixels.

height="[number]"

Specifies the height of the control in pixels.

left="[number]"

Specifies the offset in pixels from the left hand side of the dialog.

maxlength="[number]"

Specifies the maximum number of characters that can be entered into the control.

scrollbars="[y|n]

Controls whether scrollbars should be shown on the memo control.

readonly="[y|n]"

Specifies whether the memo controls contents should be readonly.

wantreturns="[y|n]"

Specifies whether the user can insert return characters into the text.

wanttabs="[y|n]"

Specifies whether the user can insert tab characters into the text.


Multi line Label Control

The multi line label control creates a read-only label in the dialog. It does not enter any data into the final template. You define a multi line edit control with the following XML code fragment:

<MultilineLabel prompt="[text]" hint="[text]" required="[y|n]" text="[text]" wordwrap="[y|n]" width="[number]" height="[number]" left="[number]"></MultilineLabel>

All attributes are optional. They are used as follows:

prompt="[text]"

Specifies the text prompt that appears to the left of the edit control.

hint="[text]"

Specifies the text that appears as a help hint when the user holds the mouse over the control in the dialog.

required="[y|n]"

Specifies whether this is a required field.

text="[text]"

Specifies the default text in the control when first displayed.

wordwrap="[y|n]"

Specifies if words are to be wrapped within the label.

width="[number]"

Specifies the maximum width of the edit box in pixels.

height="[number]"

Specifies the height of the control in pixels.

left="[number]"

Specifies the offset in pixels from the left hand side of the dialog.


Panel Control

The Panel control allows a single line of textual input. You define a panel control with the following XML code fragment:

<Panel prompt="[text]" hint="[text]" width="[number]" height="[number]" left="[number]" bevelinner="[number]" bevelouter="[number]" borderwidth="[number]" borderstyle="[number]" color="[number]" alignment="[number]" autospace="[y|n]" spaceabove="[number]" spacebelow="[number]" font="[string]" fontcolor="[string]" fontsize="[number]" fontstyle="[number]"></Panel>

All attributes are optional. They are used as follows:

prompt="[text]"

Specifies the text prompt that appears to the left of the edit control.

hint="[text]"

Specifies the text that appears as a help hint when the user holds the mouse over the control in the dialog.

width="[number]"

Specifies the width of the panel in pixels.

height="[number]"

Specifies the height of the panel in pixels.

left="[number]"

Specifies the left position of the panel in pixels.

bevelinner="[number]"

Determines the style of the inner bevel if present. See the Language Guide for a list of possible values.

bevelouter="[number]"

Determines the style of the outer bevel if present. See the Language Guide for a list of possible values.

borderwidth="[number]"

Specifies the distance, in pixels, between the outer and inner bevels. Use BorderWidth to specify how wide the border around the panel should be. A value of 0 means no border should appear. The border of a panel is the area between the outer and inner bevels. It is visible only if the inner bevel is raised or lowered, but affects the inset of the caption within the panel even if BevelInner is fbvNone. If the Alignment property is not ftaCenter, the Caption will be aligned to the inner edge of the border. This edge is BorderWidth pixels in from the outer bevel if BevelInner is fbvNone. It is the inner edge of the inner bevel otherwise. Don’t confuse the border of the panel with the line drawn around the panel itself. The line around the panel is specified by the BorderStyle property.

borderstyle="[number]"

Determines the style of the line drawn around the perimeter of the panel control. Use BorderStyle to specify whether the panel has a single line drawn around it. See BorderStyle constants in the Language Guide for details.

color="[number]"

Specifies the background color of the control. See Color constants in the Language Guide for details.

alignment="[number]"

Determines how the caption is aligned within the panel. Use the Alignment property to specify if the caption of a panel appears on the left, right or center of the panel. See the Alignment constants in the Language Guide for details.

autospace="[y|n]"

Determines the style of the inner bevel of a panel. Use BevelInner to provide the panel with a three-dimensional beveled look. A panel component has two bevels, an outer bevel drawn next to the border of the control, and an inner bevel drawn inside the outer bevel, separated by the number of pixels specified in the BorderWidth property. The width of the bevels, if they are drawn, is the BevelWidth property. See PanelBevel constants in the Language Guide for details.

spaceabove="[number]"

When AutoSpace is False, set SpaceAbove to the number of pixels which should separate the previous control from the top of the Panel control. If omitted, the SpaceAbove will default to 0 pixels.

spacebelow="[number]"

When AutoSpace is False, set SpaceBelow to the number of pixels which should separate the next control from the bottom of the Panel control. If omitted, the SpaceBelow will default to 0 pixels.

font="[string]"

Controls the attributes of text written on or in the control. To modify a font, change the value of the Color, Height, Name, Size, or Style of the ControlFont object. See the ControlFont object in the Language Guide for details.

fontcolor="[string]"

Specifies the color of the text. See the Color constants in the Language Guide for details. A 6 digit hexadecimal RGB value can also be specified by prefixing the value with &H, such as &HFF0000, which is Red.

fontsize="[number]"

Specifies the height of the font in points. Use Size to specify the point size of the font. If the value is negative, the internal leading that appears at the top of each line of text is included. If the value is positive, Size represents the height of the characters but not the internal leading. To determine the size of the font in pixels, use the Height property instead. The value of Size can be obtained from the height in pixels using this formula: Font.Size = -Font.Height * 72 / Font.PixelsPerInch. When the Size property has a positive value, the Height property has a negative value. When the Height property has a positive value, the Size property has a negative value

fontstyle="[number]"

Determines whether the font is normal, italic, underlined, bold, and so on. Use Style to add special characteristics to characters that use the font. See the FontStyle constants in the Language Guide for details.


Radio Button

The Radio Button control adds a radio button to the dialog. You define a radio button with the following XML code fragment:

<RadioButton prompt="[text]" hint="[text]" checked="[y|n]" width="[number]" left="[number]"></RadioButton>

All attributes are optional. They are used as follows:

prompt="[text]"

Specifies the text prompt that appears to the left of the control.

hint="[text]"

Specifies the text that appears as a help hint when the user holds the mouse over the control in the dialog.

checked="[y|n]"

Specifies whether the radio button should be initially checked.

width="[number]"

Specifies the maximum width of the control box in pixels.

left="[number]"

Specifies the offset in pixels from the left hand side of the dialog.


Radio Group Control

RadioGroupControl represents a group of radio buttons that function together. You define a radio group control with the following XML code fragment:

<RadioGroup prompt="[text]" hint="[text]" width="[number]" left="[number]" height="[number]" columns="[number]" itemindex="[number]">

<Option text="[text]"></Option>

.

.

.

</RadioGroup>

All attributes are optional. They are used as follows:

prompt="[text]"

Specifies the text prompt that appears to the left of the control.

hint="[text]"

Specifies the text that appears as a help hint when the user holds the mouse over the control in the dialog.

width="[number]"

Sets the width of the control. Omitting this value or setting it to 0 will make the control size automatically to the dialog width. Values larger than the width of the dialog will be automatically truncated to fit within the dialog.

left="[number]"

Sets the left position of the control in pixels. The default is 0 for all dynamically added dialog controls.

height="[number]"

Sets the height of the control. A default value will be used if this property is omitted.

columns="[number]"

Specifies the number of columns in the radio group. The Columns property determines the number of columns in the radio group. Its value can range from 1 to 16. The default value is 1, which means that the radio buttons are arranged in a single vertical line.

itemindex="[number]"

Indicates which radio button in the group is currently selected. ItemIndex holds the ordinal number of the selected radio button in the Items list. (The first button is 0.) The value of ItemIndex changes at run time as the user selects radio buttons. If you want one of the buttons to appear selected when the application starts, assign that button to ItemIndex at design time. Otherwise, leave ItemIndex set to the default value of -1, which means that no button is selected.

<Option text="[text]"></Option>

Used to specify the text of each radio button entry. This is the text that will be inserted into the template should this item be selected.


ISO Date Formatting

Many template elements require you to specify dates and times as string. Formativ uses an ISO standard to store dates and times as a string. The following format is used:

YYYYMMDDTHHMMSS

where

YYYY = Year

MM = Month

DD = Day

HH = 24 hour clock hour

MM = Minutes

SS = Seconds